\documentclass[a4paper,12pt,oneside]{scrreprt}
\usepackage[latin1]{inputenc}
\usepackage[T1]{fontenc}
\usepackage{ae,aecompl}
\usepackage[english]{babel}
\usepackage{amsmath}
\usepackage{amssymb}
\usepackage{amsfonts}
\usepackage{amsthm}
\usepackage{graphicx}
\usepackage{wrapfig}
\usepackage{ulem}
\usepackage{cancel}
\usepackage{float}
\usepackage{color}
\usepackage{titlesec}
\usepackage{geometry}
\geometry{verbose,a4paper,tmargin=25mm,bmargin=25mm,lmargin=15mm,rmargin=25mm}
\titlelabel{\thetitle.\quad}
\usepackage{tabularx}
\usepackage{booktabs}
\usepackage{paralist}
\usepackage{textcomp}
\usepackage[official]{eurosym}

\usepackage{hyperref}
\hypersetup{
    colorlinks=true,
    linkcolor=blue,
    filecolor=magenta,      
    urlcolor=cyan,
}

\renewcommand{\rmdefault}{phv}
\renewcommand{\sfdefault}{phv}

\begin{document}
    \begin{tabular*}{\textwidth}{c @{\extracolsep{\fill}} cc}
        \begin{large}
            \textbf{Prof. Lichter}
        \end{large} &

        \begin{minipage}[H]{3.5cm}
            \centering
            \begin{large}
                OOSC
            \end{large} \\
            \begin{large}
                WS 2019/2020
            \end{large}
        \end{minipage} &

        \begin{minipage}[H]{4cm}
            \includegraphics[keepaspectratio,width=\textwidth,angle=0]{logoswc.png}
        \end{minipage} \\
        Andreas Steffens & & \\
        Konrad F\"ogen & &  \\
        & \begin{huge}
              \textbf{Submission 2}
        \end{huge}&  \\
        & oosc@swc.rwth-aachen.de &  \\
        & & \\
        % Hier drunter mÃ¼ssen die Daten noch angepasst werden
        Issued: 4.11.2019 &
        Submission: 18.11.2019 &
        Discussion: 21.11.2019 \\
    \end{tabular*}
    \newline \newline \newline
    \begin{center}
        Submitted by 07

        \begin{tabular}{ll}
            Radu-Andrei Coanda, 344664. \\
            Clemens Frohnhofer, 333800\\
            Silas G\"unther, 382506  \\
            Christoph Kr\"amer, 318424  \\
        \end{tabular}
        \newline
        \\
        Gitlab-repository: should be public. If you cannot access it. Please get in contact with us. Thanks. \\
        https://git.rwth-aachen.de/radu.coanda/19ws-oosc
    \end{center}

    \setcounter{chapter}{2} % Aktuelles Assigment
    \section{Assignment: }
    \begin{enumerate}
        \item [a)]
            Given are the three classes Material, Aurochs and Cow. Here Aurochs is a sub-class of Material and Cow is a sub-class of Aurochs. The method writeName() declared in the class Material is overwritten in Aurochs as well as in Cow. In class Aurochs two more methods are declared. One static method writeLatin() and one non static method writeDescription(). In Cow there is only one additional static method declared writeLatin(). \\
            \\
            The following UML diagram shows the structure:\\
            \begin{center}
                \includegraphics[keepaspectratio,angle=0]{exercise2_1/uml_diagram.png}
            \end{center}
        \item[b)]
            \begin{center}
                \begin{tabular}{|c|c|}
                    \hline
                    \textbf{Statement} & \textbf{Output} \\
                    \hline
                    \hline
                    cow.writeName(); & Cow\\
                    \hline
                    aurochs.writeName(); & Cow\\
                    \hline
                    ((Material)aurochs).writeName(); &  CompileTimeError: accessing private Methode! \\
                    \hline
                    ((Aurochs)cow).writeName(); & Cow  \\
                    \hline
                    ((Cow)aurochs).writeName(); &  Cow \\
                    \hline
                    aurochs.writeLatin(); & Bos primigenius \\
                    \hline
                    auerochse.writeDescription(); &  Cow \\
                    \hline
                    ((Aurochs)material).writeName(); &  RuntimeError: material cannot be down castet to Aurochs,\\
                    & because material is not of type Aurochs or any subtype\\
                    \hline
                \end{tabular}
            \end{center}{}
    \end{enumerate}
    
    
    \section{Assignment: }
    
     \begin{center}
    	\includegraphics[keepaspectratio,angle=0]{exercise2_2/e22uml.png}
    \end{center}
    
    The diagram has some quality issues.
    
    In the diagram Cover is a sub-type of Book. This is a violation of the Is-a rule of inheritance because an instance of a cover is not an instance of a book. An instance of cover is rather a part of a book. Book and Cover should have an association relation.
    
    Author is associated with Text and with Paper. However Paper is a sub-type of Text. Thus Paper already inherits the association with Author from Text. Therefore we can remove the association between Author and Paper.
    
    Author is a subtype of Person. Actually, this is not a problem because Author is the only sub-type of Person. However, if the model is extended by further subtypes this pattern may be problematic.
    Par Example if a Proofreader class is added as a subtype of Person, there will be persons who are authors as well as proofreaders.
    
    For better readability of the diagram, we changed the ordering of classes in such a way that the sub-classes are always below the super-class.
    
    \section{Assignment: }
    Only the following type of inheritance can be found: \\
    \\
    \textbf{Restriction Inheritance:} \\
    There is a restriction inheritance between Circle and GeoObject and between Ellipse and GeoObject, because an instance of a circle is an instance of a GeoObject as well, but additionally it has a diameter. Thus only instances that satisfy that constraint are Circles. Same argument applies to Ellipse. \\
    \\
    Other forms do not occur, because ... \\
    \textbf{Subtype inheritance:} \\
    The instance sets of Circle and Ellipse are not disjoint, because a Circle is a special kind of Ellipse. \\
    \\
    \textbf{Extension inheritance:} \\
    No new features are introduced in Circle or Ellipse.\\
    \\
    \textbf{View inheritance:} \\
    There is no classification criteria which creates a different view of a GeoObject.\\
    \\
    \textbf{Variational inheritance:} \\
    No methods are redefined. \\
    \\
    \textbf{Reification inheritance:} \\
    GeoObject does not represent a general kind of data structure.\\
    \\
    \textbf{Structure inheritance:} \\
    GeoObject does not represent a general structural property.\\
    \\
    \textbf{Implementation inheritance:} \\
    GeoObject does not provide a set of features, which is necessary to implement the abstraction of a Circle or an Ellipse.\\
    \\
    \textbf{Facility inheritance:} \\
    GeoObject does not provide a set of logically related features.\\
    \\
    \\
    \textbf{Changing the inheritance structure reasonably:}
    At first glance one might think it is a good idea to apply specialization inheritance, while making Circle a subtype of Ellipse, as a Circle is a special kind of Ellipse. Although in this example the substitution principle would hold, as there are only setters and getters and the Circle class could implement them for the conjugateDiameter, this could change rapidly in the future when e.g. a calculateArea method is introduced in the ellipse class (see lecture example rectangle and square). Moreover it is not intuitive when the user of the class Circle can set two different diameter properties. \\ 
    \\
    Another idea would be to use extension inheritance and make Ellipse a subtype of Circle. If correctly implemented, it would obey the substitution principle even when further adaptations to the Circle class occur. The downside is that this would lead to a mixture of restriction and extension inheritance which is again very inintuative for the user.\\
    \\
    Instead it is better to use structure inheritance and create a new abstract class GeoObjectWithDiameter which represents all GeoObject with a diameter property. Circle and Ellipse are then special types of that abstract type. This way the substitution principle is obeyed even if in the future Ellipse or Circle are extended. In comparison to the given structure the new structure reduces the redundancy of code, but introduces therefore a new class. \\
    \\
    \textbf{GIT commit id: db0de6d8}
    
    \section{Assignment: }
		\begin{center}
			\includegraphics[width=\linewidth]{exercise2_4/uml_diagram.png}
		\end{center}
	
		Here are two possible groups of subclasses for the class Person. The first one is GenderPerson, a group to add functionality dependent from the gender of the person. The other one is JobPerson, adding functionality dependent from the job of a person. Both are two different classification criteria. Therefore this is a view inheritance. \\
		For implementation, view the code.\\
	
		\textbf{GIT commit id: 979a6f7fa36dea83cf2146bdd84946ef104026b4}


    \section{Assignment: }
    	\begin{center}
	    	\includegraphics[keepaspectratio,angle=0]{exercise2_5/uml25.png}
	    \end{center}
	    Here we implement a Queue by inheritance from a List. This type of inheritance is clearly implementation inheritance, as the List offers features, that are necessary for implementing the associated features of a Queue. \\
	    \\
	    No other form of inheritance applies, because ...\\
	    \textbf{Model Inheritance:} The Queue is not a subtype of List and does not extend or restrict any List specific features/attributes. Also the Queue is not a view of a List. \\
	    \textbf{Variation Inheritance:} Althoug some methods have a common name, the implementation of the Queue goes further than just redefining some mehtods of the List. Thus also no kind of Variational Inheritance can be found. \\
	    \textbf{Reification Inheritance:} A Queue is not a partial/complete implementation of the data structure List. \\
	    \textbf{Structure inheritance:} The Queue does not contain special properties of the List. \\
	    \textfb{Facility Inheritance:} The List does not provide a set of logically related features. It is a data structure.\\
	    \\
	    Generally implementation inheritance can be avoided by either using structure inheritance or by giving up the inheritance relation and replace it by a use relation. \\
	    In this case it would be a good idea to replace the inheritance by a use relation. The Queue would internally store and handle the elements in a list.\\
	    \\
	    For the code: \\
	    \textbf{GIT commit id: e100f610} \\
    \section{Assignment: }
	    \begin{center}
	    	\includegraphics[keepaspectratio,angle=0]{exercise2_6/uml.png}
	    \end{center}
	    
		As you can see, the class StandardOutputLogger inherits from Logger. The StandardOutputLogger logs to the standard output and not to a file, but has the same signature. Therefore it is a functional variance inheritance. \\
		For implementation, view the code.\\
		
		\textbf{GIT commit id: 9560790dd73adaea4bd224ad5a1561faf74ea8ed}
    
    \section{Assignment: Polymorphism}
    \subsection{Part 1}
    To parse an expression into an expression tree we would need to parse the expression 
    somehow. This can be done by first parsing the infix (human-readable expression) 
    to something that we can use to build or tree with. For this first task we can use 
    something like Dijkstra's shunting-yard algorithm. Good resources to understand this 
    can be found \href{https://www.youtube.com/watch?v=Wz85Hiwi5MY}{here} and
    \href{https://en.wikipedia.org/wiki/Shunting-yard_algorithm}{here}. As this we find 
    is outside the scope of this lecture we'll skip for now.\\

    The important thing to note is that the output of our first algorithm looks something 
    like this $3\; 4\; +$ for an input expression like this one $3 + 4$. This first notation
    is also known as Reverse Polish notation (RPN), which is basically postfix notation of a binary
    expression tree. Finally we can parse this form easily by using a stack and creating a Numer
    Node each time we encounter a numeric value and each time we encounter an operator we pop the
    last two elements off the stack and create the necessary Node Type (e.g. Minus, Plus, etc.) with
    the two popped elements as subtrees. Then we add the new Node to the stack. The last element
    remaining on the stack is our resulting expression tree.
    
    \subsection{Part 2}
    See code.\\
    \textbf{GIT commit id: 3d9cefcd}
    
    \subsection{Part 3}
    See code.\\
    \textbf{GIT commit id: 3d9cefcd}

    The "test application" is in form of a test suit that computes multiple expressions with
    the requested operators. Can be found together with the rest of the code.
    \section{Assignment: Polymorphism, Inheritance \& Patterns}
    Unfortunately not all group members participated in this exercise. Therefore and because of short notice of this circumstances to the others, we were not able to provide a solution to this task.
    
\end{document}
